/*

   Cal4TI v1.3 by Jan Vornberger <jan@uos.de>



   compile with zcc +ti83ansi -startup=1 -o cal4ti.bin cal4ti.c

*/



#include <stdio.h>

#include <games.h>

#include "cal4ti.h"



void main()

{

	int flag=1;



  	printf("%c2J",155);	// clear screen and jump to top



	OpeningScreen();

	CalcDayOfWeek();

	FillYear();



	//Calc position of first selection

	s_t=7+mywday;



	DrawCal();

	DrawSelection();



	//main loop - awaiting input

	while(flag)

	{

		switch(getk())

		{

			case K_DOWN:

				if ((s_t+7)<21)

				{

					s_t+=7;

					DrawSelection();

				}

				break;

			case K_UP:

				if ((s_t-7)>=0)

				{

					s_t-=7;

					DrawSelection();

				}

				break;

			case K_RIGHT:

				if ((s_t+1)<21)

				{

					s_t++;

					DrawSelection();

				}

				break;

			case K_LEFT:

				if ((s_t-1)>=0)

				{

					s_t--;

					DrawSelection();

				}

				break;

			case K_PLUS:

				myday+=7;

				if (myday>year[mymonth-1])

				{

					myday%=year[mymonth-1];

					mymonth++;

					if(mymonth>12)

					{

						mymonth=1;

						myyear++;



						//leap year?

						FillYear();

					}

				}

				CalcDayOfWeek();



				//adjust selection

				if(s_t<7) s_t=0; else s_t-=7;



				DrawCal();

				DrawSelection();



				break;

			case K_MINUS:

				myday-=7;

				if (myday<1)

				{

					myday+=31;

					mymonth--;

					if(mymonth==0)

					{

						mymonth=12;

						myyear--;



						//leap year?

						FillYear();

					}

				}

				CalcDayOfWeek();



				//adjust selection

				if (s_t>13) s_t=0; else s_t+=7;



				DrawCal();

				DrawSelection();



				break;

			case K_ENTER:

				EditWindow();

				DrawCal();

				DrawSelection();

				break;

			case K_EXIT:

				flag=0;

		}

	}



	//Saving data...

	//Z88dk has no file support for Ti83 (not yet), therefore

	//I use the shell ION for now. This way I don't have to deal

	//with 'files' because _everything_ is saved. I'm no asm guru

	//though, therefore I'm not sure if I have to define default

	//values for all vars to not create any memory leaks.

	//Maybe somebody can enlighten me here...



	//Exiting...

  	printf("%c2JThank you for using Cal4TI",155);

}



// Shows program titel, author and months of year,

// then waits for input from user

int OpeningScreen()

{

	int read=0,pos=0;

	char chtmp='';



	//Drawing screen

   printf("%c[7m/   Cal4TI by Jan Vornberger   \\",27);

  printf("%c[27m|    Z88DK Small C+ Program    |",27);

	printf("|                              |");

	printf("| 01-Jan 04-Apr  07-Jul 10-Oct |");

	printf("| 02-Feb 05-May  08-Aug 11-Nov |");

	printf("| 03-Mar 06-Jun  09-Sep 12-Dec |");



      //printf("|          12.12.1212          |");

	printf("|          ");

	printf("%c",ch[0]);

	printf("%c.",ch[1]);

	printf("%c",ch[2]);

	printf("%c.",ch[3]);

	printf("%c",ch[4]);

	printf("%c",ch[5]);

	printf("%c",ch[6]);

	printf("%c",ch[7]);

	printf("          |");



	//Don't know, how to solve the 'scroll problem'

       //printf("\\______________________________/");



	//Input routine

	while(1)

	{

		while(!(((chtmp=getchar())>=48 && chtmp<=57) || chtmp=='\n' || chtmp==8))

			;

		if (chtmp=='\n')

		{

			//Converting input

			for(read=0;read<8;read++)

				ch[read]-=48;

			myday=ch[0]*10+ch[1];

			mymonth=ch[2]*10+ch[3];

			myyear=ch[4]*1000+ch[5]*100+ch[6]*10+ch[7];



			//'hidden' reset option

			if(myday==42)

			{

				myday=1;

				ch[0]=0;

				ch[1]=1;

				appanz=0;

			}



			//Convert it back -> for next start of cal4ti

			for(read=0;read<8;read++)

				ch[read]+=48;



			return(0);

		}

		if (chtmp==8)

		{

			pos--;

			if (pos<0) pos=9;

			if (pos==2) pos--;

			if (pos==5) pos--;



			read--;

			if (read<0) read=7;

		}

		else

		{

			ch[read]=chtmp;



			printf("%c[6;",27);

			printf("%dH",pos+12);

			printf("%c",chtmp);

			pos++;

			read++;



			//'jump' over the points

			if (pos==2) pos++;

			if (pos==5) pos++;

			if (pos==10)

			{

				pos=0;

				read=0;

			}

		}

	}

}



//The name is program :-)

void CalcDayOfWeek()

{

	int day,month,yr;



	day=myday;

	month=mymonth;

	yr=myyear;



	if(month==1 || month==2) 

	{

		month+=12;

		yr--;

	}

	mywday=((month+1)*3)/5;

	mywday=day+(month*2)+mywday+yr+(yr/4)-(yr/100)+(yr/400)+2;

	mywday=mywday-((mywday/7)*7);



	mywday-=2;

	if(mywday<0) mywday=7+mywday;

}



//Figure out if it is a leap year

void FillYear()

{

	int s=0;



	if (!(myyear % 4)) s=1;

	if (!(myyear % 100)) s=0;

	if (!(myyear % 400)) s=1;

	if (!(myyear % 2000)) s=0;

	if (s) year[1]=29; else year[1]=28;

}



//Draws calendar

void DrawCal()

{

	int i,j,k,r,tmp,tmppos,tmpmonth,tmpmyyear,tmpyear,tmpc;

	char apptmp[5];



	//Prepare screen

  	printf("%c2J",155); //jump back to top of screen



	//Drawing headline

	printf("/");

  	printf ("%c[7m  ",27); //reversed



	for(i=0;i<7;i++)

	{

		printf("%c",wdays[i*2]);

		printf("%c  ",wdays[i*2+1]);

	}

  	printf ("%c[27m\\",27);



	//Drawing main part



	//Vars for turn of the year possibility

	tmps1year=myyear;

	tmps2year=myyear;



	/* very complicated calculation ;-)

	    (myday -1): to make things easier myday is between 0-30,

	                 but originally it's between 1-31

	    (7+mywday)  : myday should be 'under' it's weekday

	*/

	i=(myday-1)-(7+mywday);

	if (i<0)

	{

		//display: prev. month, current month



		tmps1month=(10+mymonth)%12;

		mod=year[tmps1month];

		i+=mod;

		tmps1month++;	//change to 'normal' format

		tmps2month=mymonth;

	

		//turn of the year?

		if (tmps1month==12) tmps1year--;

	}

	else

	{

		//display: current month, next month



		mod=year[mymonth-1];

		tmps1month=mymonth;

		tmps2month=(mymonth%12)+1;



		//turn of the year?

		if (tmps2month==1) tmps2year++;

	}



	for(r=0;r<3;r++)

	{

		//Drawing days



		k=i;	//save i

		printf("| ");

		for(j=0;j<7;j++)

		{

			tmp=((i++)%mod)+1;

			if (tmp<10) printf(" 0%d ",tmp); else printf(" %d ",tmp);

		}

		printf(" |");





		//Drawing appointmentes



		i=k;	//restore i

		printf("| ");

		for(j=0;j<7;j++)

		{

			tmp=((i++)%mod)+1;

			if(i>mod)

			{

				tmpmonth=tmps2month;

				tmpmyyear=tmps2year;

			}

			else

			{

				tmpmonth=tmps1month;

				tmpmyyear=tmps1year;

			}



			//look up appointments...

			tmpc=0;

			for(k=0;k<appanz;k++)

			{

				tmppos=k*30;

				tmpyear=apps[tmppos+2]*256 + apps[tmppos+3];



				if(apps[tmppos]==tmp && apps[tmppos+1]==tmpmonth && tmpyear==tmpmyyear)

					apptmp[tmpc++]=apps[tmppos+4];

			}

			apptmp[tmpc]=0;



			//...and print labels (centered)

			tmp=(4-tmpc)/2;

			tmppos=(4-tmpc)-tmp;



			for(k=0;k<tmppos;k++)

				printf(" ");



			printf("%s",apptmp);



			for(k=0;k<tmp;k++)

				printf(" ");



		}

		printf(" |");

	}



	//scroll problem again

	//printf("\\______________________________/");



	//'clear' first row

	for(j=0;j<7;j++)

		DrawSprite(spr_mask,j,0);

}



void DrawSelection()

{

	s_x=s_t % 7;

	s_y=s_t / 7;



	//remove old selection

	DrawSprite(spr_mask,s_xo,s_yo);



	//draw new one

	DrawSprite(spr_or,s_x,s_y);



	s_xo=s_x;

	s_yo=s_y;

}



void DrawSprite(int type, int x, int y)

{

	putsprite(type,x*12+6,y*16+7,selection);

}



void EditWindow()

{

	int i,tmpday,tmpmonth,tmpyear,tmpmyyear,tmppos;

	int flag=1,ex=0,ey=0;

	char tmpch;

	int napp,vday,vmonth,vyear;



	//Calculation of day and month which are selected

	tmpday=s_t-7+myday-mywday;

	if(tmpday<1)

	{

		//prev. month



		tmpmonth=tmps1month;

		tmpday+=mod;

		tmpmyyear=tmps1year;

	}

	else if(tmpday>mod)

	{

		//next month

		tmpmonth=tmps2month;

		tmpday%=mod;

		tmpmyyear=tmps2year;

	}

	else

	{

		//current month

		tmpmonth=mymonth;

		tmpmyyear=myyear;

	}



	//Drawing window

	DrawEditWindow(tmpday,tmpmonth,tmpmyyear,1);



	//Awaiting input

	printf("%c[2;3H>",27);

	while(flag)

	{

		switch(tmpch=getk())

		{

			case K_DOWN:

				printf("%c[",27);

				printf("%d;3H|",2+ey);



				ey++;

				if(ey>3) ey=0;

				ex=0;



				printf("%c[",27);

				printf("%d;3H>",2+ey);



				break;

			case K_UP:

				printf("%c[",27);

				printf("%d;3H|",2+ey);



				ey--;

				if(ey<0) ey=3;

				ex=0;



				printf("%c[",27);

				printf("%d;3H>",2+ey);



				break;

			case K_RIGHT:

				ex++;

				if(ex==1) ex=2;



				printf("%c[",27);

				printf("%d;",2+ey);

				printf("%dH",4+ex);



				break;

			case K_LEFT:

				if(ex==2) ex=0; else ex--;

				if(ex<0) ex=25;



				printf("%c[",27);

				printf("%d;",2+ey);

				printf("%dH",4+ex);



				break;

			case K_CLEAR:

				if (eapps[ey]!=-1) //Is the slot empty?

				{

					//Copy last appointment over selected

					//appointment to delete it.

					tmppos=eapps[ey]*30;

					tmpyear=(appanz-1)*30;	//recycle tmp var

					for(i=0;i<30;i++)

					{

						apps[tmppos+i]=apps[tmpyear+i];

					}

					appanz--;



					//Update window

					DrawEditWindow(tmpday,tmpmonth,tmpmyyear, 1);



					//Restore cursor position

					ex=0;

					printf("%c[",27);

					printf("%d;3H>",2+ey);

				}

				break;

			case K_ENTER:

				flag=0;

				break;

			default:

				if(ex>25)

				{

					ex=0;

					printf("%c[",27);

					printf("%d;",2+ey);

					printf("%dH",4+ex);

				}



				if(ex==0)

				{

					//label



					if(eapps[ey]==-1)

					{

						//empty one

						if(appanz==MAX_APPS)

						{

							//no empty slots available



							vyear=32767; //this is a signed var



							//find oldest entry

							for(i=0;i<MAX_APPS;i++)

							{

								tmppos=i*30;

								tmpyear=apps[tmppos+2]*256 + apps[tmppos+3];



								if(vyear>tmpyear)

								{

									vday=apps[tmppos];

									vmonth=apps[tmppos+1];

									vyear=tmpyear;

									napp=i;

								}

								else if(vyear==tmpyear)

								{

									if(vmonth>apps[tmppos+1])

									{

										vday=apps[tmppos];

										vmonth=apps[tmppos+1];

										napp=i;

									}

									else if(vmonth==apps[tmppos+1])

									{

										if(vday>apps[tmppos])

										{

											vday=apps[tmppos];

											napp=i;

										}

									}

								}

							}



							//Display warning

							tmppos=napp*30;

							tmpyear=apps[tmppos+2]*256 + apps[tmppos+3];



							printf("%c[2;2H",27);

							printf("*-Overwriting:--");



							//kinda ugly, but no width formatting control,

							//and I didn't want to use this pragma stuff *shrug*

							tmpyear=apps[tmppos];

							if (tmpyear<10) printf("0");

							printf("%d.",tmpyear);



							tmpyear=apps[tmppos+1];

							if (tmpyear<10) printf("0");

							printf("%d.",tmpyear);



							tmpyear=(apps[tmppos+2]*256 + apps[tmppos+3])/100;

							if (tmpyear<10) printf("0");

							printf("%d",tmpyear);



							tmpyear=(apps[tmppos+2]*256 + apps[tmppos+3])-(tmpyear*100);

							if (tmpyear<10) printf("0");

							printf("%d",tmpyear);

							



							printf("-*\n");

							printf("||%c-",apps[napp*30+4]);

							printf("%s|\n",apps+napp*30+5);

							printf("||       [Y]es/[N]o?        |\n");

							printf("|*--------------------------*\n");



							//Read answer...

							tmppos=getk(); //recycle tmp var

							

							//Redraw screen

							DrawEditWindow(tmpday,tmpmonth,tmpmyyear,0);



							//...and react

							printf("%c[",27); //Restore cursor position

							if (tmppos!='Y')

							{

								printf("%d;3H>",2+ey);

								break; //get outta here

							}

							else

							{

								printf("%d;4H",2+ey);

							}

						}

						else

						{

							//still empty slots available

							napp=appanz++;

						}



						//fill in date

						tmppos=napp*30;

						apps[tmppos]=tmpday;

						apps[tmppos+1]=tmpmonth;

						apps[tmppos+2]=(tmpmyyear-(tmpmyyear%256))/256;

						apps[tmppos+3]=tmpmyyear%256;



						//fill message with spaces

						for(i=5;i<29;i++)

							apps[tmppos+i]=' ';

						apps[tmppos+29]=0;

						eapps[ey]=napp;

					}

					apps[eapps[ey]*30+4]=tmpch;

					ex=1;

				}

				else

				{

					apps[eapps[ey]*30+ex+3]=tmpch;

				}

				printf("%c",tmpch);

				if (ex==1) printf("-");

				ex++;



				break;

		}

	}

}



//Draws edit window for day tmpday.tmpmonth.tmpmyyear, sets up eapps[] on request

void DrawEditWindow(int tmpday, int tmpmonth, int tmpmyyear, int doeapps)

{

	int i,tmppos,tmpc,tmpyear;



	printf("%c[1;3H",27);

	printf("*--------------------------*\n");



	tmpc=0;

	for(i=0;i<appanz;i++)

	{

		tmppos=i*30;

		tmpyear=apps[tmppos+2]*256 + apps[tmppos+3];



		if(apps[tmppos]==tmpday && apps[tmppos+1]==tmpmonth && tmpyear==tmpmyyear)

		{

			if (doeapps) eapps[tmpc]=i;

			tmpc++;

			printf("| |%c-",apps[tmppos+4]);

			printf("%s|\n",apps+tmppos+5);

		}

	}

	if (doeapps)

	{

		for(i=tmpc;i<4;i++)

			eapps[i]=-1;

	}

	for(i=0;i<(4-tmpc);i++)

		printf("| |                          |\n");

	printf("| *--------------------------*\n");

}

